import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  AssetsUser,
  AssetsUserParam
} from '@/api/oa/assets/user/model/index';

/**
 * 分页查询开发成员
 */
export async function pageAssetsUser(params: AssetsUserParam) {
  const res = await request.get<ApiResult<PageResult<AssetsUser>>>(
    '/oa/assets-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询开发成员列表
 */
export async function listAssetsUser(params?: AssetsUserParam) {
  const res = await request.get<ApiResult<AssetsUser[]>>('/oa/assets-user', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询开发成员
 */
export async function getAssetsUser(id: number) {
  const res = await request.get<ApiResult<AssetsUser>>('/oa/assets-user/' + id);
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加开发成员
 */
export async function addAssetsUser(data: AssetsUser) {
  const res = await request.post<ApiResult<unknown>>('/oa/assets-user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改开发成员
 */
export async function updateAssetsUser(data: AssetsUser) {
  const res = await request.put<ApiResult<unknown>>('/oa/assets-user', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除开发成员
 */
export async function removeAssetsUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/oa/assets-user/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除开发成员
 */
export async function removeBatchAssetsUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/oa/assets-user/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/oa/assets-user/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
